LISTEN	EQM $FFB1
SECOND	EQM $FF93
UNLSN	EQM $FFAE
TALK	EQM $FFB4
TKSA	EQM $FF96
UNTLK	EQM $FFAB
CIOUT	EQM $FFA8
ACPTR	EQM $FFA5
READST	EQM $FFB7

CHKIN	EQM $FFC6
CHKOUT	EQM $FFC9
CHRIN	EQM $FFCF
CHROUT	EQM $FFD2
CLALL	EQM $FFE7
CLOSE	EQM $FFC3
CLRCHN	EQM $FFCC
OPEN	EQM $FFC0
GETIN	EQM $FFE4

SETLFS	EQM $FFBA
SETNAM	EQM $FFBD

adrlo	EQM $FB
adrhi	EQM $FC

target	EQM drive+3
bank	EQM drive+4
track	EQM drive+5
sector	EQM drive+6
binflg	EQM drive+7
mirflg	EQM drive+8
pgsize	EQM drive+9
delay	EQM drive+10

        processor 6502

#if MACH == 64
	org $801
#endif
#if MACH == 20-3
	org $401
#endif
#if MACH == 20-8
	org $1201
#endif
#if MACH == 264 || MACH == 20
	org $1001
#endif
#if MACH == 128
	org $1c01

	hex 1b 08 d2 07 9e 28 c2 28 34 35 29 aa c2 28 34 
	hex 36 29 ac 32 35 36 aa 32 38 29 00 00 00
#else
	hex 1b 08 d2 07 9e 28 c2 28 34 33 29 aa c2 28 34 
	hex 34 29 ac 32 35 36 aa 32 38 29 00 00 00
#endif

start	lda #147
	jsr CHROUT
getkey	jsr status
	jsr GETIN
	cmp #'F
	bne nxt1
	lda binflg
	eor #2
	sta binflg
	jmp getkey
nxt1	cmp #'M
	bne nxt2
	lda mirflg
	eor #128
	sta mirflg
	jmp getkey
nxt2	cmp #'A
	bne nxt3
	lda target
	cmp #$e0
	bne nxt9
	lda #$60
nxt9	clc
	adc #$20 
	sta target
	jmp getkey
nxt3	cmp #'C
	bne nxt4
	lda pgsize
	bne nxt8
	lda #$20
nxt8	asl
	sta pgsize
	jmp getkey
nxt4	cmp #'S
	bne nxt5
	jsr dir
	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b "                    ",13,"                    ",13,145,145,0
#else
	dc.b "                                       ",13,145,0
#endif
	jmp getkey
nxt5	cmp #'Q
	bne nxt6
	jsr primm
	dc.b 13,"BYE!",13,0
	rts
nxt6	cmp #95
	bne nxt7
	jmp start
nxt7	cmp #'B
	bne nxta
	lda bank
	cmp #3
	bne nxtb
	lda #$ff
	sta bank
nxtb	inc bank

nxta	jmp getkey
	
dir	jsr opendir
	ldx #254
	jsr skip
	bcs end
next1	ldy #7
next2	jsr getentry
	bcs end
	ldx #2
	jsr skip
	bcs end
	dey
	bne next2
	jsr getentry
	bcc next1
end	jsr CLRCHN
	lda #2
	jsr CLOSE
	rts

getentry
	tya
	pha
	jsr readdir
	and #$80
	bne getfile
	ldx #29
	jsr skip
	pla
	tay
	rts
getfile	jsr readdir
	sta track
	jsr readdir
	sta sector
	ldx #16
next3	jsr readdir
	bcs end1
	jsr CHROUT
	dex
	bne next3 

	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b 13,"FLASH (",95,"/Y/N)?",13,145,145,0
#else
	dc.b " FLASH (",95,"/Y/N)?",13,145,0
#endif
	jsr CLRCHN
in	jsr GETIN
	cmp #'Y
	beq yes
	cmp #'N
	beq no
	cmp #95
	bne in
	pla
	jsr end
	sec
	rts
	
no	txa
	ldx #2
	jsr CHKIN
	ldx #11
	jsr skip
	tax
	pla
	tay
end1	rts

yes	pla
	jsr end
	jsr opencmd

	ldx #15
	jsr CHKOUT
	jsr primm
	dc.b "U0>V2",0	;syntax error on all 157x, okay on 154x
	jsr CLRCHN

	ldx #15
	jsr CHKIN
	jsr CHRIN
	cmp #$30
	beq fast
	lda #16
	dc.b $2c
fast	lda #8
	sta delay

err	jsr readdir
	bcc err
	jsr CLRCHN

	jsr openbuf

	ldx #15
	jsr CHKOUT
	jsr primm
	dc.b "B-P 2 0",0
	jsr CLRCHN

	lda #<drive
	sta adrlo
	lda #>drive
	sta adrhi
	ldx #2
	jsr CHKOUT
	ldy #0
nxt	lda (adrlo),y
	jsr CHROUT
	iny
	bne nxt
	lda #2
	jsr CLOSE
	ldx #15
	jsr CHKOUT
	jsr primm
	dc.b "U3",0
	jsr CLRCHN
	lda #15
	jsr CLOSE
	sec
	rts

nam	DC.B "$0"
buf	dc.b "#2"
cmd	dc.b "U0",190,"M1"

openbuf	lda #2
	ldy #>buf
	ldx #<buf
	jsr SETNAM
	lda #2
	ldx #8
	ldy #2
	jsr SETLFS
	jsr OPEN
	rts

opencmd	lda #7
	ldy #>cmd
	ldx #<cmd
	jsr SETNAM
	lda #15
	ldx #8
	ldy #15
	jsr SETLFS
	jsr OPEN
	rts

opendir	lda #2
	ldy #>nam
	ldx #<nam
	jsr SETNAM
	lda #2
	ldx #8
	ldy #2
	jsr SETLFS
	jsr OPEN
	ldx #2
	jsr CHKIN
	rts

readdir	jsr CHRIN
	pha
	jsr READST
	clc
	bne enddir
	pla
	rts

enddir	pla
	sec
	rts

skip	jsr readdir
	bcs endskip
	dex
	bne skip
endskip	rts

primm	pha		;from C128 ROM
	txa
	pha
	tya
	pha
	ldy #0
primm1	tsx
	inc $104,x
	bne primm2
	inc $105,x
primm2	lda $104,x
	sta adrlo
	lda $105,x
	sta adrhi
	lda (adrlo),y
	beq primm3
	jsr CHROUT
	bcc primm1
primm3	pla
	tay
	pla 
	tax
	pla
	rts

status	jsr primm

#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b 19,"  FLASH  PROGRAMMER",13,"   FOR DISK DRIVES",13
	dc.b "(C)NICOLAS WELTE 2002",13,13
	dc.b "HTTP://",13,"  PEOPLE.FREENET.DE/",13,"                 X1541",13
	dc.b "OPTIONS:",13
#else
	dc.b 19,"   FLASH PROGRAMMER FOR DISK DRIVES",13
	dc.b "       (C) NICOLAS WELTE 2002",13
	dc.b "    HTTP://PEOPLE.FREENET.DE/X1541",13,13
	dc.b "OPTIONS:",13
#endif
	dc.b 18,"F",146,"ORMAT    ",0
	lda binflg
	bne skip1
	lda #18
	jsr CHROUT
skip1	jsr primm
	dc.b "BIN",146,"/",0
	lda binflg
	cmp #2
	bne skip2
	lda #18
	jsr CHROUT
skip2	jsr primm
	dc.b "PRG",146,13

	dc.b 18,"M",146,"IRROR    ",0
	lda target
	cmp #$bf
	bcs mirfix
	lda #0
	sta mirflg
mirfix	lda mirflg
	bne skip3
	lda #18
	jsr CHROUT
skip3	jsr primm
	dc.b "OFF",146,"/",0
	lda mirflg
	cmp #128
	bne skip4
	lda #18
	jsr CHROUT
skip4	jsr primm
	dc.b "ON",146,13

	dc.b 18,"A",146,"DDRESS   $",0
	lda target
	cmp #$80
	bne skp1
	jsr primm
	dc.b "8000",13,0
skp1	cmp #$a0
	bne skp2
	jsr primm
	dc.b "A000",13,0
skp2	cmp #$c0
	bne skp3
	jsr primm
	dc.b "C000",13,0
skp3	cmp #$e0
	bne skp4
	jsr primm
	dc.b "E000",13,0

skp4	jsr primm
	dc.b 18,"B",146,"ANK      ",0
	lda bank
	clc
	adc #48
	jsr CHROUT

	jsr primm
	dc.b 13,18,"C",146,"HIPTYPE  ",0
	lda pgsize
	bne skip5
	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b "29C020/040",13,0
#else
	dc.b "AT29C020/AT29C040",13,0
#endif
	beq skip7

skip5	and #$80
	beq skip6
	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b "29C512/010",13,0
#else
	dc.b "AT29C512/AT29C010",13,0
#endif
	bne skip7

skip6	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b "AT29C256  ",13,0
#else
	dc.b "AT29C256         ",13,0
#endif

skip7	jsr primm
#if MACH == 20 || MACH == 20-3 || MACH == 20-8
	dc.b 13,18,"S",146,"ELECT FILE AND FLASH",13
#else
	dc.b 13,18,"S",146,"ELECT FILE AND START FLASHING",13
#endif
	dc.b 18,95,146,"RESTART PROGRAM",13
	dc.b 18,"Q",146,"UIT PROGRAM",13,13,0

	rts

drive	incbin "flash41.bin"